﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

//  new 
using System.ComponentModel;
using System.Threading;

namespace ProgressBar1 {
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window {


        public MainWindow() {
            InitializeComponent();
        }


        private void Window_Loaded(object sender, RoutedEventArgs e) {

            int n = 100;


            progressbar.Minimum = 0;
            progressbar.Maximum = n;

            worker = new BackgroundWorker();
            worker.WorkerReportsProgress = true;
            worker.ProgressChanged += worker_ProgressChanged;
            worker.DoWork += dotheWork;  // the run-method
            worker.RunWorkerAsync();
        }

        private BackgroundWorker worker = null;

        // Wichtig, diese Methode wird nach jeder Änderung aufgerufen.
        // Die Abfrage "istEnde" dient als EndeAktion
        void worker_ProgressChanged(object sender, ProgressChangedEventArgs e) {
            progressbar.Value = e.ProgressPercentage;
            if (e.ProgressPercentage == progressbar.Maximum) {
                progressbar.Value = 0;
                Message("Finish", "Do some studid work, Extrakaese-Pizza");
            }
            else {
                labelProgress.Content = "Progress: " + (progressbar.Value * 100.0 / progressbar.Maximum).ToString("0.0") + " %";
            }
        }

        public void Message(String text, String title) {
            MessageBox.Show(text, title, MessageBoxButton.OK, MessageBoxImage.Information);
        }


        // setValue(i);
        public void dotheWork(object sender, DoWorkEventArgs e) {
            int n = 0;
            for (int i = 0; i < 100; i++) {
                // working
                Thread.Sleep(300);
                worker.ReportProgress(++n); Thread.Sleep(5);
            }

        }

        private void bnOk_Click(object sender, RoutedEventArgs e) {
            Close();
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e) {
            e.Cancel = false;
        }

    }
}